;------------------------------------------------------------------------------
; Ovladaci program pre kazetopaskovu jednotku KZD 01 a PMD 85-3

; Disassembling a komentar Roman Brik 2005/2006
;------------------------------------------------------------------------------
; Port 4F - riadiaci port 8255
; Port 4E - vstup
;   bit 0 - datovy bit z KZD (DATA 1)
;   bit 1 - datovy bit z KZD (DATA 0)
;   bit 2 - "doraz" pasky (MOTOR 1 + MOTOR 2)
;   bit 3 - Write Protect - nepouzite
; Port 4D - vystup
;   bit 0 - posun dopredu
;   bit 1 - zrychleny posun dopredu
;   bit 2 - posun dozadu
;   bit 3 - zrychleny posun dozadu
;   bit 4 - zapis dat
;   bit 5 - potvrdenie zapisu dat
;   bit 6 - citlivost
;   bit 7 - datovy bit do KZD
;------------------------------------------------------------------------------
; Inicializacia.
;------------------------------------------------------------------------------
B000 JMP  B043

;------------------------------------------------------------------------------
; Navrat do monitora.
;------------------------------------------------------------------------------
B003 JMP  EC40

;------------------------------------------------------------------------------
; Vykonanie prikazu FO - format pasky.
;------------------------------------------------------------------------------
B006 CALL B3F7      ; inicializuj porty
B009 PUSH H         ; odpamataj aktualnu adresu ukazovatela v programe
B00A CALL B3B2      ; pretoc pasku na zaciatok
B00D MVI  A,AE      ; 10101110b - posun vpred, zapis, znizena citlivost citania
B00F OUT  4D
B011 LXI  B,0000    ; pockaj 3s - preskoc zavadzaciu cast pasky
B014 CALL B3AB
B017 CALL B3AB
B01A CALL B3AB
B01D CALL B3AB
B020 LXI  H,0000    ; bloky su cislovane o 0
B023 SHLD B123      ; uloz cislo bloku
B026 CALL B1B1      ; formatuj blok
B029 LHLD B123      ; precitaj cislo bloku
B02C INX  H         ; zvys o 1
B02D IN   4E
B02F ANI  04        ; dosiahol si koniec pasky?
B031 JZ   B023      ; ak nie, vrat sa do slucky
B034 MVI  A,B3      ; 10110011b - rychlo vzad, znizena citlivost citania
B036 OUT  4D
B038 LXI  B,0000    ; pockaj 768ms nez sa uvolni doraz
B03B CALL B3AB
B03E CALL B3B2      ; pretoc pasku na zaciatok
B041 POP  H         ; obnov aktualnu adresu ukazovatela v programe
B042 RET

;------------------------------------------------------------------------------
; Inicializacia - modifikuje BASIC a prida prikazy KLO, KSV, FO.
; vstup: -
; vystup: modifikovany BASIC
; meni: BC, DE, A, PSW
;------------------------------------------------------------------------------
B043 PUSH H         ; odpamataj aktualnu adresu ukazovatela v programe
B044 LXI  H,B123    ; adresa mien prikazov
B047 LXI  D,1B15    ; cielova adresa v interpreteri BASICu
B04A LXI  B,0008    ; velkost prenasanych dat
B04D CALL B118      ; presun nazvy prikazov
B050 LXI  H,B133    ; adresa s adresami obsluhy prikazov
B053 LXI  D,1974    ; cielova adresa v interpreteri BASICu
B056 LXI  B,0006    ; velkost prenasanych dat
B059 CALL B118      ; presun adresy obsluhy prikazov
B05C POP  H         ; obnov aktualnu adresu ukazovatela v programe
B05D RET

;------------------------------------------------------------------------------
; Vykonanie prikazu KSV n - ulozenie suboru.
;------------------------------------------------------------------------------
B05E CALL 08C8      ; ziskaj parameter za prikazom
B061 CALL 0554      ; celociselna hodnota parametra do DE
B064 PUSH H         ; odpamataj aktualnu adresu ukazovatela v programe
B065 XCHG
B066 SHLD B123      ; zapis cislo pozadovaneho bloku
B069 LXI  H,0000    ; vynuluj pocet chybnych blokov
B06C SHLD B129
B06F LXI  H,2400    ; pociatocna adresa v pamati,
B072 SHLD B127      ; odkial je ulozeny zapisovany blok
B075 CALL B0FB      ; zisti velkost programu v 1kB blokoch
B078 CALL B149      ; zapis program
B07B LDA  B129      ; zisti pocet chybne zapisanych blokov
B07E ANA  A
B07F JZ   B08B      ; ak je vsetko v poriadku, skoc dopredu
B082 LXI  H,E413    ; hlaska "++ File error ++"
B085 CALL EE4B      ; zobraz chybu
B088 CALL E4A1      ; pockaj na klavesu
B08B XRA  A
B08C STA  2400
B08F LXI  H,B139    ; hlaska "NEXT";PEEK('B123)
B092 CALL 16E6      ; zobraz hlasku a cakaj na klavesu
B095 POP  H         ; obnov aktualnu adresu ukazovatela v programe
B096 RET

;------------------------------------------------------------------------------
; Vykonanie prikazu KLO n - nacitanie suboru.
;------------------------------------------------------------------------------
B097 CALL 08C8      ; ziskaj parameter za prikazom
B09A CALL 0554      ; celociselna hodnota parametra do DE
B09D PUSH H         ; odpamataj aktualnu adresu ukazovatela v programe
B09E XCHG
B09F SHLD B123      ; zapis cislo pozadovaneho bloku
B0A2 LXI  H,0000    ; vynuluj pocet chybnych blokov
B0A5 SHLD B129
B0A8 MVI  A,89      ; SK A: MOD 0, A-OUT, CH-IN,  SK B: MOD 0, B-OUT, CL-IN
B0AA OUT  4F
B0AC LXI  H,2400    ; pociatocna adresa v pamati,
B0AF SHLD B127      ; odkial je ulozeny zapisovany blok
B0B2 CALL B259      ; precitaj prvy blok programu
B0B5 ANA  A
B0B6 JNZ  B0E6      ; pri chybe skoc dopredu
B0B9 LDA  2400      ; zisti pocet blokov
B0BC CPI  0E
B0BE JNC  B0E6      ; ak je ich viac ako 13, je to chyba, skoc dopredu
B0C1 DCR  A
B0C2 JZ   B0D3      ; ak je program dlhy jeden blok, mame vsetko, skoc dopredu
B0C5 INR  A         ; nastav pocet blokov
B0C6 STA  B125
B0C9 CALL B18B      ; a nahraj zbytok programu
B0CC LDA  B129      ; zisti, ci doslo ku chybe
B0CF ANA  A
B0D0 JNZ  B0E6      ; ak ano, skoc dopredu
B0D3 CALL B0FB      ; zisti velkost programu v 1kB blokoch
B0D6 XRA  A         ; inicializuj systemove premenne po nahrati programu
B0D7 STA  2400
B0DA INX  H
B0DB SHLD AE7A
B0DE SHLD AE7C
B0E1 SHLD AE7E
B0E4 POP  H         ; obnov aktualnu adresu ukazovatela v programe
B0E5 RET

B0E6 LXI  H,E413    ; hlaska "++ File error ++"
B0E9 CALL EE4B      ; zobraz chybu
B0EC CALL E4A1      ; pockaj na klavesu
B0EF LXI  H,0000    ; oznac, ze nie je ziadny program
B0F2 SHLD 2401
B0F5 LXI  H,2402
B0F8 JMP  B0D6

;------------------------------------------------------------------------------
; Zisti velkost programu v 1kB blokoch, ktore bude program zaberat na paske.
; vstup: -
; vystup: pocet 1 KB blokov na adrese 2400h a B125
; meni: HL, DE, A, PSW
;------------------------------------------------------------------------------
B0FB LXI  H,2401    ; adresa zaciatku programu v BASICu
B0FE MOV  E,M       ; vyber adresu nasledujuceho riadku
B0FF INX  H
B100 MOV  A,M       ; zisti, ci je to 0
B101 ORA  E
B102 JZ   B10A      ; ak ano si na konci
B105 MOV  D,M
B106 XCHG           ; adresa nasledujuceho riadku do v programe do HL
B107 JMP  B0FE

B10A MOV  A,H       ; spocitaj pocet obsadenych kB
B10B SUI  20
B10D ANI  FC
B10F RRC
B110 RRC
B111 STA  2400      ; a uloz
B114 STA  B125
B117 RET

;------------------------------------------------------------------------------
; Kopirovanie bloku pamati.
; vstup: HL - odkial, DE - kam, BC - kolko
; vystup: skopirovany blok pamati
; meni: vsetky
;------------------------------------------------------------------------------
B118 MOV  A,M
B119 STAX D
B11A INX  H
B11B INX  D
B11C DCX  B
B11D MOV  A,B
B11E ORA  C
B11F JNZ  B118
B122 RET

;------------------------------------------------------------------------------
; Inicializacne data.
;------------------------------------------------------------------------------
B123 DB CB,4C,4F          ; "KLO"
B126 DB CB,53,56          ; "KSV"
B129 DB C6,4F             ; "F0"
B12B DB 00,00,00,00
B12F DB 00,00,00,00
B133 DW B097,B05E,B006    ; load, save, format

;------------------------------------------------------------------------------
; po inicializacii su pouzivane tieto pamatove bunky
;------------------------------------------------------------------------------
B123 DS 2                 ; cislo bloku
B125 DS 1                 ; pocet 1kB blokov, ktore program zabera na paske
B126 DS 1
B127 DS 2                 ; adresa v pamati, kde je/bude ulozeny blok
B129 DS 2                 ; chybovy kod, resp. pocet "zlych" blokov
B12B DS 1                 ; pocet opakovani pri hladani bloku

;------------------------------------------------------------------------------
B139 DB ""NEXT";"
B140 DB BD                ; "PEEK"
B141 DB "('B123)"
B148 DB 00

;------------------------------------------------------------------------------
; Zapise program na pasku. DW hodnota na adrese B129h musi byt vynulovana.
; vstup: cislo prveho bloku na adrese B123h
;        pocet blokov na adrese B125h
;        adresa dat na adrese B127h
; vystup: hodnota na adrese B129h - 00h = OK, >00h = chyba
; meni: vsetky
;------------------------------------------------------------------------------
B149 CALL B3F7      ; inicializacia portov
B14C LDA  B125      ; pocet zapisovanych blokov
B14F MOV  B,A       ; do B
B150 PUSH B         ; odpamataj pocet blokov
B151 CALL B209      ; zapis blok na pasku
B154 ANA  A         ; ak bol zapis bloku v poriadku,
B155 JZ   B15F      ; skoc dopredu
B158 LHLD B129      ; zvys pocet chybnych zapisov
B15B INX  H
B15C SHLD B129
B15F LHLD B123      ; zvys cislo bloku
B162 INX  H
B163 SHLD B123
B166 LHLD B127      ; posun adresu v pamati o 1024
B169 LXI  D,0400
B16C DAD  D
B16D SHLD B127
B170 POP  B         ; obnov pocitadlo blokov
B171 CALL EC74      ; otestuj klavesu STOP
B174 RZ             ; vrat sa, ak bola stlacena
B175 DCR  B         ; zniz pocet blokov
B176 JNZ  B150      ; opakuj pre vsetky bloky
B179 RET

;------------------------------------------------------------------------------
; Precita program z pasky. DW hodnota na adrese B129h musi byt vynulovana.
; vstup: cislo prveho bloku na adrese B123h
;        pocet blokov na adrese B125h
;        cielova adresa v pamati na adrese B127h
; vystup: hodnota na adrese B129h - 00h = OK, >00h = chyba
; meni: vsetky
;------------------------------------------------------------------------------
B17A CALL B3F7      ; inicializacia portov
B17D CALL B259      ; precitaj blok z pasky
B180 ANA  A
B181 JZ   B18B      ; ak bolo citanie v poriadku, skoc
B184 LHLD B129      ; zvys pocet chybne precitanych blokov
B187 INX  H
B188 SHLD B129
B18B LHLD B123      ; zvys cislo bloku
B18E INX  H
B18F SHLD B123
B192 LHLD B127      ; posun adresu v pamati o 1024
B195 LXI  D,0400
B198 DAD  D
B199 SHLD B127
B19C CALL EC74      ; otestuj STOP
B19F JNZ  B1A6      ; skoc dopredu, ak nebola stlacena
B1A2 STA  B129      ; modifikuj pocet "chybne" precitanych blokov
B1A5 RET

B1A6 LDA  B125      ; zniz pocet citanych blokov
B1A9 DCR  A
B1AA STA  B125
B1AD JNZ  B17D      ; a opakuj, ak este neboli precitane vsetky
B1B0 RET

;------------------------------------------------------------------------------
; Format jedneho bloku.
; vstup: cislo bloku na adrese B123h
; vystup: sformatovany blok
; meni: vsetky
;------------------------------------------------------------------------------
; hlavicka = 00 01 FF LL HH CRC
; data = 00 01  1024-krat 5E  CRC1 CRC2 55 55
;------------------------------------------------------------------------------
B1B1 LHLD B123      ; precitaj cislo bloku
B1B4 XCHG           ; a uloz do DE
B1B5 CALL B3ED      ; zapis synchronizacnu sekvenciu - 00h a 01h
B1B8 MVI  A,FF      ; zapis FFh
B1BA CALL B34A
B1BD MOV  A,E       ; zapis nizsi byte cisla bloku
B1BE CALL B34A
B1C1 MOV  A,D       ; zapis vyssi byte cisla bloku
B1C2 CALL B34A
B1C5 MOV  A,D       ; vytvor CRC pre hlavicku
B1C6 ADD  E
B1C7 CMA
B1C8 INR  A
B1C9 CALL B34A      ; a zapis
B1CC LXI  B,00C8
B1CF CALL B3AB      ; cakaj 2.344 ms
B1D2 CALL B3ED      ; zapis synchronizacnu sekvenciu - 00h a 01h
B1D5 LXI  H,0000    ; HL = 0000h - "CRC"
B1D8 LXI  B,0400    ; BC = 0400h - dlzka bloku 1024 bytov
B1DB MVI  A,5E      ; zapis 5Eh - ako "prazdnu" formatovaciu hodnotu do kazdeho
B1DD CALL B34A      ; bytu bloku
B1E0 DCX  B         ; zniz pocitadlo bytov
B1E1 MOV  A,B
B1E2 ORA  C
B1E3 JNZ  B1DB      ; a opakuj pre vsetky byty
B1E6 MOV  A,H       ; uloz "CRC1"
B1E7 CALL B34A
B1EA MOV  A,H       ; uloz "CRC2"
B1EB CALL B34A
B1EE MVI  A,55      ; zapis 55h
B1F0 CALL B34A
B1F3 MVI  A,55      ; zapis 55h
B1F5 CALL B34A
B1F8 LXI  B,0190    ; zdrzanie 39ms po zapise bloku
B1FB MVI  A,0B
B1FD DCR  A
B1FE JNZ  B1FD
B201 NOP
B202 DCX  B
B203 MOV  A,B
B204 ORA  C
B205 JNZ  B1FB
B208 RET

;------------------------------------------------------------------------------
; Zapise blok na pasku.
; vstup:  pozadovane cislo bloku na adrese B123h
;         adresa data na adrese B127h
; vystup: A = 01h pri chybe, 00 inak
; meni: vsetky
;------------------------------------------------------------------------------
; hlavicka = 00 01 FF LL HH CRC
; data = 00 01  1024 bytov dat  CRC1 CRC2 55 55
;------------------------------------------------------------------------------
B209 CALL B2AB      ; najdi na paske pozadovany blok
B20C JNZ  B252      ; ak sa blok nenasiel, skoc dopredu
B20F MVI  A,AE      ; 10101110b
B211 OUT  4D
B213 LXI  B,00C8
B216 CALL B3AB      ; cakaj 2.344 ms
B219 LXI  B,0400    ; blok ma 1024 bytov
B21C LHLD B127      ; adresa odkial sa maju citat data
B21F XCHG           ; uloz do DE
B220 CALL B3ED      ; zapis synchronizacnu sekvenciu - 00h a 01h
B223 LXI  H,0000    ; CRC = 0
B226 LDAX D         ; vyber byte z adrsy v DE
B227 CALL B34A      ; zapis na pasku
B22A INX  D         ; posun adresu
B22B DCX  B         ; zniz pocitadlo bytov
B22C MOV  A,B
B22D ORA  C
B22E JNZ  B226      ; opakuj pre vsetky byty
B231 MOV  A,H       ; uloz "CRC1"
B232 CALL B34A
B235 MOV  A,H       ; uloz "CRC2"
B236 CALL B34A
B239 MVI  A,55      ; zapis 55h
B23B CALL B34A
B23E MVI  A,55      ; zapis 55h
B240 CALL B34A
B243 MVI  A,BE      ; 10111110b
B245 OUT  4D
B247 LXI  B,05DC    ; zdrzanie 17.5ms
B24A CALL B3AB
B24D DCR  A         ; 11111111b
B24E OUT  4D
B250 XRA  A         ; flag - OK
B251 RET

B252 MVI  A,FF      ; 11111111b - zastav KZD
B254 OUT  4D
B256 MVI  A,01      ; flag - chyba
B258 RET

;------------------------------------------------------------------------------
; Precita blok z pasky.
; vstup: pozadovane cislo bloku na adrese B123h
;        cielova adresa na adrese B127h
; vystup: A = 02h, ak sa nenajde blok, 01h pri chybe citania, 00 OK
; meni: vsetky
;------------------------------------------------------------------------------
; hlavicka = 00 01 FF LL HH CRC
; data = 00 01  1024 bytov dat  CRC1 CRC2 55 55
;------------------------------------------------------------------------------
B259 MVI  E,04
B25B PUSH D         ; opamataj pocitadlo opakovani
B25C CALL B2AB      ; najdi na paske pozadovany blok
B25F JNZ  B2A3      ; ak sa blok nenasiel, skoc dopredu
B262 MOV  A,E
B263 CPI  03        ; podla poctu opakovani zvol typ povelu
B265 MVI  A,BE      ; 10111110b - znizena citlivost
B267 JNC  B26C
B26A MVI  A,FE      ; 11111110b - normalna citlivost
B26C OUT  4D
B26E LXI  B,0064
B271 CALL B3AB      ; cakaj 1.1 ms
B274 LXI  B,0400    ; blok ma 1024 bytov
B277 LHLD B127      ; HL = adresa v pamati
B27A CALL B3C8      ; najdi synchronizacnu sekvenciu 00h a 01h
B27D XCHG           ; adresa v pamati do DE
B27E LXI  H,0000    ; CRC = 0
B281 CALL B378      ; precitaj byte z KZD
B284 STAX D         ; uloz byte do pamati
B285 INX  D         ; posun adresu
B286 DCX  B         ; zniz pocitadlo
B287 MOV  A,B
B288 ORA  C
B289 JNZ  B281      ; opakuj pre vsetky byty
B28C CALL B378      ; precitaj byte z KZD
B28F CALL B378      ; precitaj byte z KZD
B292 MOV  A,H       ; prever CRC
B293 ORA  L
B294 POP  D         ; obnov pocitadlo pokusov
B295 MVI  A,FF      ; 11111111b - KZD do kludoveho stavu
B297 OUT  4D
B299 MVI  A,00      ; flag - OK
B29B RZ             ; ak je CRC OK, vrat sa
B29C DCR  E         ; zniz pocitadlo opakovani
B29D JNZ  B25B      ; ak nie je nulove, skus to znovu
B2A0 MVI  A,01      ; flag - chyba
B2A2 RET

B2A3 POP  D         ; obnov DE
B2A4 MVI  A,FF      ; 11111111b - KZD do kludoveho stavu
B2A6 OUT  4D
B2A8 MVI  A,02      ; flag - nenasiel sa pozadovany blok
B2AA RET

;------------------------------------------------------------------------------
; Najde na paske pozadovany blok.
; vstup: pozadovane cislo bloku na adrese B123h
; vystup: NZ - pri chybe, Z - OK
; meni: vsetky
;------------------------------------------------------------------------------
B2AB MVI  A,04      ; pocet povolenych opakovani spatneho pretacania
B2AD STA  B12B      ; uloz hodnotu
B2B0 LDA  B12B      ; precitaj pocet opakovani
B2B3 CPI  03        ; a podla poctu zvol typ povelu
B2B5 MVI  A,BE      ; 10111110b - normalne vpred, znizena citlivost
B2B7 JNC  B2BC
B2BA MVI  A,FE      ; 11111110b - normalne vpred, normalna citlivost
B2BC OUT  4D
B2BE CALL B32A      ; cakaj na odozvu z KZD v intervaloch 6.38ms
B2C1 CALL B3C8      ; najdi synchronizacnu sekvenciu 00h a 01h
B2C4 CALL B378      ; precitaj byte z KZD
B2C7 CPI  FF
B2C9 JNZ  B2BE      ; ak to nie je FF, skoc hladat dalej
B2CC CALL B378      ; precitaj byte z KZD
B2CF MOV  E,A       ; nizsi byte cisla bloku
B2D0 CALL B378      ; precitaj byte z KZD
B2D3 MOV  D,A       ; vyssi byte cisla bloku
B2D4 CALL B378      ; precitaj byte z KZD
B2D7 ADD  D         ; dopocitaj CRC
B2D8 ADD  E
B2D9 JNZ  B2BE      ; ak CRC nesedi, skoc hladat dalej
B2DC LHLD B123      ; pozadovane cislo bloku do HL
B2DF CALL B39E      ; porovnaj pozadovane a najdene cislo bloku
B2E2 RZ             ; nasiel si, vrat sa
B2E3 JC   B311      ; sme za pozadovanym blokom (DE > HL), skoc dopredu
B2E6 CALL B3A4      ; sme pred pozadovanym blokom, HL = HL - DE
B2E9 MOV  A,H       ; zisti ako sme vzdialeny od pozadovaneho bloku
B2EA ANA  A
B2EB JNZ  B2F4
B2EE MOV  A,L
B2EF CPI  04
B2F1 JC   B2BE      ; ak je to menej ako 4, skoc opat hladat
B2F4 LXI  D,FFFD    ; DE = -3, vypocitaj pocet sektorov, na preskocenie,
B2F7 DAD  D         ; HL = HL - 3, aby sme sa dostali do blizkosti na 3 bloky
B2F8 MVI  A,BC      ; 10111100b - pretacanie dopredu
B2FA OUT  4D
B2FC PUSH H         ; pretoc pasku dopredu, aby sme sa priblizili na 3 bloky
B2FD CALL B334      ; cakaj na odozvu z KZD v intervaloch 5,6ms
B300 IN   4E        ; cakaj na zaciatok bloku
B302 ANI  07
B304 JZ   B300
B307 POP  H
B308 DCX  H         ; zniz pocitadlo preskakovanych blokov
B309 MOV  A,H
B30A ORA  L
B30B JNZ  B2FC      ; opakuj preskakovanie sektorov
B30E JMP  B2B0      ; skoc do hlavnej slucky hladania

B311 LDA  B12B      ; zniz pocet pokusov vratit pasku dozadu
B314 DCR  A
B315 STA  B12B
B318 JNZ  B31D      ; ak neboli vsetky pokusy, skoc dopredu
B31B INR  A         ; inak nastav flag - chyba
B31C RET

B31D XCHG           ; prehod pozadovane a najdene cislo bloku
B31E CALL B3A4      ; HL = HL - DE, najdi pocet blokov, ktore treba preskocit
B321 LXI  D,0003    ; DE = 3, plus 3, aby sme sa dostali pred pozadovany blok
B324 DAD  D         ; HL = HL + 3
B325 MVI  A,B3      ; 10110011b - pretacanie dozadu
B327 JMP  B2FA      ; skoc najst prislusny blok

;------------------------------------------------------------------------------
; Caka na odozvu z KZD v intervaloch 6.38ms
; vstup: -
; vystup: -
; meni: HL, A, PSW
;------------------------------------------------------------------------------
B32A LXI  H,011C
B32D CALL B33E
B330 JNZ  B32A
B333 RET

;------------------------------------------------------------------------------
; Caka na odozvu z KZD vintervaloch 5,6ms
; vstup: -
; vystup: -
; meni: HL, A, PSW
;------------------------------------------------------------------------------
B334 LXI  H,00FA
B337 CALL B33E
B33A JNZ  B334
B33D RET

;------------------------------------------------------------------------------
; Caka na odozvu z KZD - HL * 22,46us
; vstup: HL - timeout
; vystup: Z - doslo k timeoutu
;         NZ - prisla odozva od KZD
; meni: HL, A, PSW
;------------------------------------------------------------------------------
B33E IN   4E
B340 ANI  07
B342 RNZ
B343 DCX  H
B344 MOV  A,H
B345 ORA  L
B346 JNZ  B33E
B349 RET

;------------------------------------------------------------------------------
; Odoslanie bytu do KZD.
; vstup: A - posielany byte
;        HL - CRC
; vystup: poslany byte do KZD, HL - zmenene CRC
; meni: HL, A, PSW
;------------------------------------------------------------------------------
B34A PUSH B         ; odpamataj BC
B34B MVI  C,80      ; nastav masku na 7. bit do C
B34D MOV  B,A       ; do B posielany byte
B34E ANA  C         ; odmaskuj posielany bit
B34F ADI  FF        ; nastav CY podla daneho bitu
B351 MVI  A,5C      ; riadiaci povel pre KZD
B353 RAR            ; pridaj prislusny bit z posielaneho bytu
B354 OUT  4D        ; posli do KZD - X0101110b
B356 PUSH PSW       ; odpamataj PSW a A
B357 XRI  20        ; komplementuj 5.bit riadiaceho bytu - potvrdenie
B359 OUT  4D        ; a posli do KZD - X0001110b
B35B RAL            ; 4 T  - posielany bit do CY
B35C SBB  A         ; 4 T  - A = 00h pre CY = 0, A = FFh pre CY = 1
B35D DAD  H         ; 10 T - zdvojnasob HL - CY = 1 pre HL > 7FFFh
B35E ADC  A         ; 4 T  - PE pre A=00h a CY=0 alebo A=FF a CY=1, inak PO
B35F MVI  A,07      ; 7 T
B361 JPE  B366      ; 10 T
B364 XRA  L         ; 4 T
B365 MOV  L,A       ; 5 T
B366 POP  PSW       ; obnov povodny povel
B367 OUT  4D        ; a posli do KZD
B369 MVI  A,03      ; zdrzanie 25.4us
B36B DCR  A
B36C JNZ  B36B
B36F MOV  A,C       ; odrotuj masku doprava
B370 RRC
B371 MOV  C,A
B372 MOV  A,B       ; posielany byte naspat do A
B373 JNC  B34E      ; ak neboli odoslane vsetky bity, skoc do slucky
B376 POP  B         ; obnov BC
B377 RET

;------------------------------------------------------------------------------
; Precita byte z KZD.
; vstup: HL - CRC
; vystup: A - precitany byte, HL - zmenene CRC
; meni: HL, A, PSW
;------------------------------------------------------------------------------
B378 PUSH B         ; odpamataj BC
B379 MVI  B,01      ; "pocitadlo bitov" do B
B37B IN   4E        ; precitaj stav KZD
B37D ANI  07
B37F JZ   B37B      ; ak nie je pripravena, cakaj
B382 RAR            ; prijaty bit z bytu do CY (DATA 1)
B383 PUSH PSW       ; odpamataj CY
B384 SBB  A         ; 4 T  - A = 00h pre CY = 0, A = FFh pre CY = 1
B385 DAD  H         ; 10 T - zdvojnasob HL - CY = 1 pre HL > 7FFFh
B386 ADC  A         ; 4 T  - PE pre A=00h a CY=0 alebo A=FF a CY=1, inak PO
B387 MVI  A,07      ; 7 T
B389 JPE  B395      ; 10 T
B38C XRA  L         ; 4 T
B38D MOV  L,A       ; 5 T
B38E IN   4E        ; pockaj kym skonci datovy impulz na DATA 1 alebo DATA 0
B390 ANI  03
B392 JNZ  B38E
B395 POP  PSW       ; obnov CY
B396 MOV  A,B
B397 RAL            ; odrotuj pocitadlo a zaroven pridaj prijaty bit
B398 MOV  B,A
B399 JNC  B37B      ; pre vsetkych 8 bitov
B39C POP  B         ; obnov BC
B39D RET

;------------------------------------------------------------------------------
; Porovna HL a DE.
; vstup: HL, DE - porovnavane hodnoty
; vystup: Z = 1 ak HL == DE
;         CY = 1 ak HL < DE
; meni: A, PSW
;------------------------------------------------------------------------------
B39E MOV  A,H
B39F CMP  D
B3A0 RNZ
B3A1 MOV  A,L
B3A2 CMP  E
B3A3 RET

;------------------------------------------------------------------------------
; Odpocita DE od HL, teda HL = HL - DE.
; vstup: HL, DE - hodnoty
; vystup: HL - vysledok
;         Z = 1 ak HL == DE
;         CY = 1 ak HL < DE
; meni: HL, A, PSW
;------------------------------------------------------------------------------
B3A4 MOV  A,L
B3A5 SUB  E
B3A6 MOV  L,A
B3A7 MOV  A,H
B3A8 SBB  D
B3A9 MOV  H,A
B3AA RET

;------------------------------------------------------------------------------
; Cakacia slucka BC * 11,72us.
; vstup: BC - time
; vystup: -
; meni: BC, A, PSW
;------------------------------------------------------------------------------
B3AB DCX  B
B3AC MOV  A,B
B3AD ORA  C
B3AE JNZ  B3AB
B3B1 RET

;------------------------------------------------------------------------------
; pretoci pasku nazaciatok
; vstup: -
; vystup: paska na zaciatku
; meni: BC, A, PSW
;------------------------------------------------------------------------------
B3B2 MVI  A,B3      ; 10110011b
B3B4 OUT  4D
B3B6 LXI  B,01F4    ; cakaj 5,86 ms
B3B9 CALL B3AB
B3BC IN   4E
B3BE ANI  04        ; si na zaciatku pasky?
B3C0 JZ   B3BC      ; ak nie, vrat sa do slucky
B3C3 MVI  A,FF      ; 11111111b
B3C5 OUT  4D
B3C7 RET

;------------------------------------------------------------------------------
; Najde synchronizacnu sekvenciu 00h a 01h
; vstup: -
; vystup: -
; meni: A, PSW
;------------------------------------------------------------------------------
B3C8 IN   4E
B3CA ANI  02        ; je to uroven L ?
B3CC JZ   B3C8      ; nie, cakaj
B3CF IN   4E        ; ano, otestuj ci to nie je len zakmit
B3D1 ANI  02        ; je to uroven L ?
B3D3 JZ   B3C8      ; nie, cakaj
B3D6 MVI  A,02      ; ano, pockaj 18 us
B3D8 DCR  A
B3D9 JNZ  B3D8
B3DC IN   4E        ; cakaj na uroven H ?
B3DE RAR
B3DF JNC  B3DC
B3E2 RAR
B3E3 JC   B3CF      ; ak je aktivny aj bit urovne L, skoc naspat
B3E6 IN   4E        ; je este aktivna uroven H ?
B3E8 RAR
B3E9 JNC  B3DC      ; nie, cakaj
B3EC RET

;------------------------------------------------------------------------------
; Zapise na pasku synchronizacnu sekvenciu bloku. Teda byty 00h a 01h
; vstup: -
; vystup: zapisane byty 00h a 01h
; meni: HL, A, PSW
;------------------------------------------------------------------------------
B3ED XRA  A
B3EE CALL B34A      ; zapis 00h
B3F1 MVI  A,01
B3F3 CALL B34A      ; zapis 01h
B3F6 RET

;------------------------------------------------------------------------------
; inicializacia portu GPIO-1 pre KZD 01
;.......................................
B3F7 MVI  A,A1      ; SK A: MOD 1, A-OUT,  SK B: MOD 0, B-OUT, CL-IN
B3F9 OUT  4F
B3FB MVI  A,0D      ; 1->C6 povolenie prerusovacieho signalu INTR pre vystup A
B3FD OUT  4F
B3FF RET
;------------------------------------------------------------------------------
